Home | History | Annotate | Download | only in bind
      1 #!/bin/bash
      2 
      3 #
      4 # Copyright (c) International Business Machines  Corp., 2005
      5 # Author: Avantika Mathur (mathurav (at] us.ibm.com)
      6 #
      7 # This library is free software; you can redistribute it and/or
      8 # modify it under the terms of the GNU Lesser General Public
      9 # License as published by the Free Software Foundation; either
     10 # version 2.1 of the License, or (at your option) any later version.
     11 #
     12 # This library is distributed in the hope that it will be useful,
     13 # but WITHOUT ANY WARRANTY; without even the implied warranty of
     14 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
     15 # Lesser General Public License for more details.
     16 #
     17 # You should have received a copy of the GNU Lesser General Public
     18 # License along with this library; if not, write to the Free Software
     19 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
     20 #
     21 
     22 SETS_DEFAULTS="${TCID=test13} ${TST_COUNT=1} ${TST_TOTAL=1}"
     23 declare -r TCID
     24 declare -r TST_COUNT
     25 declare -r TST_TOTAL
     26 export TCID TST_COUNT TST_TOTAL
     27 
     28 tst_resm TINFO "***************TEST13***************"
     29 tst_resm TINFO "bind: uncloneable child to shared parent."
     30 tst_resm TINFO "************************************"
     31 
     32 . "${FS_BIND_ROOT}/bin/setup" || (tst_resm TWARN "Setup of bind/test13 failed" && tst_exit)
     33 export result=0
     34 
     35 
     36 
     37 
     38 trap 'ERR=$? ; ERR_MSG="caught error near: ${BASH_SOURCE[0]}:${FUNCNAME[0]}:${LINENO}:$_ (returned ${ERR})"; break' ERR
     39 
     40 while /bin/true ; do
     41 	# This loop is for error recovery purposes only
     42 
     43 
     44 	"${FS_BIND_ROOT}/bin/makedir" share parent1
     45 	"${FS_BIND_ROOT}/bin/makedir" share parent2
     46 	"${FS_BIND_ROOT}/bin/makedir" share share1
     47 	"${FS_BIND_ROOT}/bin/makedir" share share2
     48 	"${FS_BIND_ROOT}/bin/makedir" unclone parent1/child1
     49 
     50 	mount --bind parent1 share1
     51 	mount --bind parent2 share2
     52 	mkdir parent1/child1/x
     53 	mount --bind "$disk1" parent1/child1/x
     54 	mkdir parent2/child2
     55 	mount --bind parent1/child1 parent2/child2 2> /dev/null || result=$? # mount should fail
     56 
     57 	break
     58 done
     59 trap 'ERR=$? ; tst_resm TWARN "bind/test13: caught error near: ${BASH_SOURCE[0]}:${FUNCNAME[0]}:${LINENO}:$_ (returned ${ERR})"' ERR
     60 if [ -n "${ERR_MSG}" ]; then
     61 	tst_resm TWARN "bind/test13: ${ERR_MSG}"
     62 	ERR_MSG=""
     63 	result=$ERR
     64 fi
     65 trap '' ERR
     66 {
     67 	umount parent1/child1/x
     68 	umount parent1/child1
     69 	umount share1
     70 	umount share1
     71 	umount share2
     72 	umount share2
     73 	umount parent2
     74 	umount parent1
     75 
     76 
     77 	rm -rf parent* share*
     78 	cleanup
     79 } >& /dev/null
     80 if [ $result -eq 0 ]
     81 then
     82         tst_resm TFAIL "bind/test13: FAILED: bind: uncloneable child to shared parent."
     83         exit 1
     84 else
     85         tst_resm TPASS "bind/test13: PASSED"
     86         exit 0
     87 fi
     88 
     89 
     90 tst_exit
     91